#ifndef VY_VK_GPU_H
#define VY_VK_GPU_H

#include <volk/volk.h>


#ifdef _WIN32
struct HINSTANCE__;
struct HWND__;
#elif defined(VY_USE_XLIB)
struct _XDisplay;
#endif

typedef struct {
#ifdef _WIN32
    struct HINSTANCE__ *hInstance;
    struct HWND__ *hWnd;
#elif defined(VY_USE_XLIB)
    struct _XDisplay *display;
    unsigned long window;
#endif
} vy_native_window;


typedef struct {
    VkInstance instance;
    VkDebugUtilsMessengerEXT messenger;
    VkAllocationCallbacks *alloc_cb;
    VkPhysicalDevice phys_device;
    VkDevice device;
    VkSurfaceKHR surface;
    VkQueue graphics_queue;
    VkQueue compute_queue;
    VkQueue present_queue;
    uint32_t graphics_family;
    uint32_t compute_family;
    uint32_t present_family;

    vy_native_window native_window;

    VkPhysicalDeviceDescriptorIndexingProperties descriptor_indexing_props;
    VkPhysicalDeviceProperties phys_device_props;
} vy_vk_gpu;

#ifndef VY_VK_DONT_DEFINE_GPU_GLOBAL
extern vy_vk_gpu g_gpu;
#endif

#endif
