#ifndef VY_VK_SWAPCHAIN_H
#define VY_VK_SWAPCHAIN_H

#include <volk/volk.h>

#include "runtime/runtime.h"

#define VY_VK_MAX_SWAPCHAIN_IMAGES 3

typedef struct {
    VkSwapchainKHR swapchain;
    VkImage images[VY_VK_MAX_SWAPCHAIN_IMAGES];
    VkImageView image_views[VY_VK_MAX_SWAPCHAIN_IMAGES];
    uint32_t image_count;
    VkFormat format;
} vy_swapchain;

#ifndef VY_VK_DONT_DEFINE_SWAPCHAIN_GLOBAL
extern vy_swapchain g_swapchain;
#endif

vy_result vyCreateSwapchain(void);

vy_result vyRecreateSwapchain(void);

void vyDestroySwapchain(void);

#endif
