#ifndef VY_FILE_TAB_H
#define VY_FILE_TAB_H

#include "runtime.h"

#include <stdint.h>

/* used to identify a file (XXH3 hash of the path) */
typedef uint64_t vy_file_id;

VY_DLLEXPORT vy_result vyInitFileTab(unsigned int max_files);

VY_DLLEXPORT void vyShutdownFileTab(void);

VY_DLLEXPORT vy_file_id vyGetFileId(const char *path);

VY_DLLEXPORT vy_file_id vyGetFileIdFromSpan(vy_text_span path);

VY_DLLEXPORT vy_file_id vyAddFile(const char *path);

VY_DLLEXPORT vy_file_id vyAddFileFromSpan(vy_text_span path);

VY_DLLEXPORT const char *vyGetFilePath(vy_file_id fid);


#endif
