#ifndef VY_THREADING_H
#define VY_THREADING_H

/* platform independent threading */

#include <stdbool.h>

#include "runtime.h"

typedef struct vy_mutex_s vy_mutex;

VY_DLLEXPORT vy_mutex *vyCreateMutex(void);

VY_DLLEXPORT void vyDestroyMutex(vy_mutex *mutex);

VY_DLLEXPORT bool vyLockMutex(vy_mutex *mutex);

VY_DLLEXPORT bool vyUnlockMutex(vy_mutex *mutex);

typedef struct vy_condition_var_s vy_condition_var;

VY_DLLEXPORT vy_condition_var *vyCreateConditionVar(void);

VY_DLLEXPORT void vyDestroyConditionVar(vy_condition_var *var);

VY_DLLEXPORT void vyLockConditionVar(vy_condition_var *var);

VY_DLLEXPORT void vyUnlockConditionVar(vy_condition_var *var, bool signal);

/* The condition variable must be locked by the thread! */
VY_DLLEXPORT void vyWaitOnConditionVar(vy_condition_var *var);

typedef struct vy_thread_s vy_thread;

typedef void vy_thread_entry_fn(void *param);

VY_DLLEXPORT vy_thread *vySpawnThread(vy_thread_entry_fn *entry, void *param);

VY_DLLEXPORT void vyJoinThread(vy_thread *thread);

#endif
